/* Distributed Checksum Clearinghouse
 *
 * server tracing
 *
 * Copyright (c) 2004 by Rhyolite Software
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND RHYOLITE SOFTWARE DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL RHYOLITE SOFTWARE
 * BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 *
 * Rhyolite Software DCC 1.2.36-1.15 $Revision$
 */

#include "dccd_defs.h"

u_long dccd_tracemask = (DCC_TRACE_ANON_BIT
			 | DCC_TRACE_CLNT_BIT);


/* complain about an anonymous, non-paying client */
void
vanon_msg(const char *p, va_list args)
{
	ck_msg_rl();
	if ((DCC_TRACE_ANON_BIT & dccd_tracemask)
	    && (--rl_anon.bug_credits >= 0
		|| (DCC_TRACE_RLIM_BIT & dccd_tracemask))) {
		dcc_vtrace_msg(p, args);
	}
}



void
anon_msg(const char *p, ...)
{
	va_list args;

	va_start(args, p);
	vanon_msg(p, args);
	va_end(args);
}



/* complain about an authenticated client */
void
clnt_msg(const QUEUE *q, const char *p, ...)
{
	va_list args;

	va_start(args, p);
	if (q->clnt_id == DCC_ID_ANON || !q->rl) {
		vanon_msg(p, args);
	} else {
		ck_msg_rl();
		if ((DCC_TRACE_CLNT_BIT & dccd_tracemask)
		    && (--q->rl->bug_credits >= 0
			|| (DCC_TRACE_RLIM_BIT & dccd_tracemask))) {
			dcc_vtrace_msg(p, args);
		}
	}
	va_end(args);
}
