/* Distributed Checksum Clearinghouse
 *
 * unthreaded version of client locking
 *
 * Copyright (c) 2004 by Rhyolite Software
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND RHYOLITE SOFTWARE DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL RHYOLITE SOFTWARE
 * BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES
 * OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 *
 * Rhyolite Software DCC 1.2.36-1.20 $Revision$
 */

#include "dcc_ck.h"


/* many POSIX thread implementations have unexpected side effects on
 * ordinary system calls, so don't use the threaded version unless
 * necessary */


void
dcc_ctxts_lock(void)
{
}



void
dcc_ctxts_unlock(void)
{
}



void
dcc_syslog_lock(void)
{
}



void
dcc_syslog_unlock(void)
{
}



u_char dcc_host_locked = 1;

void
dcc_host_lock(void)
{
}



void
dcc_host_unlock(void)
{
}



#ifndef HAVE_LOCALTIME_R
void
dcc_localtime_lock(void)
{
}



void
dcc_localtime_unlock(void)
{
}
#endif /* HAVE_LOCALTIME_R */



void
dcc_clnt_unthread_init(void)
{
#ifdef DCC_WIN32
	win32_init();
#endif
}


u_char
dcc_resolve_mutex_lock(u_char opt UATTRIB)
{
	return 1;
}



void
dcc_resolve_mutex_unlock(void)
{
}



u_char
dcc_clnt_wake_resolve(void)
{
	return 0;
}



void
dcc_wf_init(DCC_WF *wf, void *mutex UATTRIB, u_char per_user)
{
	wf->ht_fd = -1;
	if (per_user)
		wf->flags |= DCC_WF_PER_USER;
	else
		wf->flags &= ~DCC_WF_PER_USER;
	wf->mutex = mutex;
}



void
dcc_wf_lock(DCC_WF *wf UATTRIB)
{
}



void
dcc_wf_unlock(DCC_WF *wf UATTRIB)
{
}
